	


	subroutine Parametri(n,y,p,d,dq,h)
	implicit double precision (a-h,o-z)

	integer n
	dimension y(0:n),p(0:n),d(0:n),dq(0:n),h(0:n)

!	potprogram detektira oscilacije	splajna i izracunava parametre napetosti 
!	koji ce smanjiti oscilacije
!
!	ulaz
!		n - zadaje broj cvorova	(broj cvorova je n+1)
!		y - vektor ordinata tocaka kroz koje treba provuci krivulju	(0:n)
!		d - vektor vrijednosti drugih derivacija splajna u cvorovima (0:n), 
!			zadani su rubni uvjeti d(0)=d(n)=0
!		dq - vektor koji zadaje druge podijeljene razlike 
!		h - vektor duljina intervala (0:n-1)
!
!	izlaz
!		p - vektor parametara napetosti	(0:n-1)



		
		integer i,i1
		double precision d1,d2,y1,y11,y2

		if (h(0).gt.0.0) then
			y11=y(1)
		else
			y11=y(0)
		endif
		y1=abs(y11)
		d1=d(1)*dq(1)
		do 10 i=1,n-2
			i1=i+1
			d2=d(i1)*dq(i1)
			y2=abs(y(i1))
			if (y2.gt.y1)y1=y2
			if (d1*d2.gt.0.0) then
				p(i)=0.0d0
			else
				if (y1.eq.0.0) then 
					p(i)=15.0d0/h(i)
				else
					p(i)=(4.0d0+1.0d0/(0.1d0+abs(y(i1)-y11)/y1))/h(i)
				endif
			endif
			y11=y(i1)
			y1=y2
			d1=d2
	10	continue
		p(0)=p(1)
		p(n-1)=p(n-2)
		end

		


	
