
	program Pres
	USE PORTLIB
	implicit double precision (a-h,o-z)


	dimension x(0:50),y(0:50),p(0:50),d(0:50),dq(0:50),h(0:50),hp(0:50),ph(0:50),c(2,500),t(500)
	character (2) A

 	DATA n/11/,nt/500/
 	DATA x/1.0d0,3.0d0,4.0d0,4.5d0,5.0d0,7.5d0,8.0d0,10.0d0,11.0d0,12.5d0,14.0d0,16.0d0,39*0.0d0/
    DATA y/-3.0d0,-3.0d0,-3.0d0,0.7d0,7.0d0,4.0d0,4.0d0,4.0d0,2.0d0,1.7d0,1.4d0,0.0d0,39*0.0d0/
    DATA p/51*0.0d0/


!	Program Pres implementira algoritam za racunanje eksponencijalnog splajna



	print *,'Zelite unijeti vlastite podatke? (da/ne)'
	read(*,*)A
	if (A.eq.'da') then
		print *,'Broj tocaka koje treba interpolirati (barem 4):'
		read *,m
		n=m-1
		print *,'Koordinate tocaka (poredati apscise u nepadajucem redoslijedu):'
		read (*,*)(x(i),y(i), i=0,n)
		print *,'parametri napetosti:'
		read (*,*)(p(i),i=0,n-1)

		print *,'Broj tocaka u kojima ce se evaluirati splajn (<=500):'
		read (*,*)nt
	endif	

	
 !	racunanje niza t tocaka u kojima ce se evaluirati splajn
	dx=(x(n)-x(0))/dble(nt-1)
	do 1 i=1,nt
		t(i)=x(0)+dx*dble(i-1)
1	continue

 !	provjera parametara napetosti
	m=0
	do 2 j=0,n
		if (p(j).ne.0) then
			m=1 
			goto 3
		endif
2	continue


3	if (m.eq.0) then
!	svi parametri napetosti su 0		
!	racunanje koeficijenata kubicnog splajna 
		call Koeficijenti(n,x,y,p,d,h,hp,ph,ier)
		if (ier.ne.0) goto 30
!	evaluacija kubicnog splajna u tockama niza t		
		do 6 j=1,nt
			call Interval(n,t(j),x,i,mflag)
				if (mflag.ne.0) 	goto 30	
			call Eodx(x,y,p,d,h,hp,ph,t(j),ex,i,n)
			c(1,j)=ex
6		continue


 !	procedura Parametri uocava oscilacije i racuna parametre napetosti
		call Parametri(n,y,p,d,dq,h)
		print *,'Izracunate vrijednosti parametara napetosti:'
		do 7 j=0,n-1
			write (*,15)p(j)
15			format(f9.5)
7		continue
	else
		do 8 j=1,nt
			c(1,j)=0.0d0
8		continue
	endif

!	racunanje koeficijenata eksponencijalnog splajna		
	call Koeficijenti(n,x,y,p,d,h,hp,ph,ier)
	if (ier.ne.0) goto 30
		
 !	evaluacija eksponencijalnog splajna u tockama niza t		
	do 9 j=1,nt
		call Interval(n,t(j),x,i,mflag)
			if (mflag.ne.0) goto 30
		call Eodx(x,y,p,d,h,hp,ph,t(j),ex,i,n)
		c(2,j)=ex 
9	continue
	
!	spremanje podataka u datoteke; a sadrzi tocke niza t, te vrijednosti splajnova u tim tockama
!	b sadrzi koordinate interpoliranih tocaka	
	open(1,file='a')
	do 11 j=1,nt
		write(1,10)t(j),c(1,j),c(2,j)
11	continue
	close(1)

10	format(1pe15.5,1pe25.15,1pe25.15)

	open(1,file='b')

	do 12 j=0,n
		write(1,20)x(j),y(j)
20		format(1pe15.5,1pe15.5)
12	continue
	close(1)
	i=system("wgnupl32 Graf.plt")

30		if (ier.eq.1) print *,'Broj cvorova je manji od 4.'
		if (ier.eq.2) print *,'Apscise nisu poredane po velicini.'
		if (ier.eq.3) print *,'LU faktorizacija nije izvrsena.' 
		if (mflag.eq.-1.or.mflag.eq.1) print *,'Tocke nisu u zadanom intervalu.'

	end






  