

		subroutine Eodx(x,y,p,d,h,hp,ph,xx,ex,i,n)
		implicit double precision (a-h,o-z)
		integer i
		double precision  xx,ex,x(0:n),y(0:n),p(0:n),d(0:n),h(0:n),hp(0:n),ph(0:n)
	


!	potprogram izracunava vrijednost ex eksponencijalnog splajna u tocki xx
!
!
!	ulaz
!		xx - realan broj u kojem treba evaluirati eksponencijalni splajn 
!		i - interval u kojem se nalazi xx
!		x - vektor apscisa tocaka kroz koje treba provuci krivulju (0:n)
!		y - vektor ordinata tocaka kroz koje treba provuci krivulju	(0:n)
!		p - vektor parametara napetosti	(0:n-1)
!		d - vektor vrijednosti drugih derivacija splajna u cvorovima, 
!			zadani su rubni uvjeti d(0)=d(n)=0
!		h - vektor duljina intervala (0:n-1)
!		hp - vektor produkata abs(p(i)*h(i)), (0:n-1)
!		ph - vektor vrijednosti exp(-hp(i)), (0:n-1)
!		n - zadaje broj cvorova	(broj cvorova je n+1)
!
!	izlaz
!		ex - vrijednost eksponencijalnog splajna u tocki xx





		integer i1
		double precision c,e,e1,t,t1,fi


		i1=i+1
		
		
		t=(xx-x(i))/h(i)
		t1=1.0d0-t
		
		if (hp(i).gt.0.5d0)then
			
			e=exp(-t*hp(i))
			e1=exp(-t1*hp(i))
			c=1.0d0-ph(i)*ph(i)
			ex=y(i1)*t+y(i)*t1+(d(i1)*(e1*(1.0d0-e*e)/c-t)+d(i)*(e*(1.0d0-e1*e1)/c-t1))/(p(i)*p(i))
		else
			e=t*hp(i)
			e1=t1*hp(i)
			c=h(i)*h(i)/(1.0d0+hp(i)*hp(i)*ph(i))
			e2=e*e
			e12=e1*e1
			call phi(e2,fi)
			fi1=fi
			call phi(e12,fi)
			fi2=fi
			ex=t*(y(i1)+d(i1)*c*(t*t*fi1-ph(i)))+t1*(y(i)+d(i)*c*(t1*t1*fi2-ph(i)))
		endif
	
		end
			
